\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{graphicx} % includegraphics command is implemented here
\title{
Stack Overflow 2018 Developer Survey \\
CMSC6950 \\
Computer Based Research Tools and Applications
}
\author{
  Chevez, Ruben \\
  \texttt{achevezguard}
  \and
  Shaik, Umar \\
  \texttt{ufshaik}
  \and
  Saki, Samira\\
  \texttt{ssaki}
  \and
  Ogbeide, Osarobo\\
  \texttt{oeo256}
  \and
  Javaid, Asma\\
  \texttt{ajavaid}
}
\date{June 2019}

\begin{document}

\maketitle

\section{1. Introduction}\label{introduction}

Every year, Stack Overflow platform developer community does a survey and ask about everything from their favorite technologies to their job preferences. In this project we will uncover the information obtained from the data of Stack Overflow 2018 Developer Survey, where more than 98,855 developers took the 30-minute survey.

\section{2. Retrieving the Data}\label{retrieving-the-data}

The data provided by Kaggle for Slack Overflow Developer Survey consist of two files

\begin{itemize}
\tightlist
\item
  SurveyResultsPublic and SurveyResultsPublic
\end{itemize}

Raw Data:

\begin{itemize}
\tightlist
\item
  Number of columns in data: 129
\item
  Number of rows in data: 98855
\end{itemize}

Fetched:

\begin{itemize}
\tightlist
\item
  Number of columns in data: 20
\item
  Number of rows in data: 98855
\end{itemize}

Refined:

\begin{itemize}
\tightlist
\item
  Number of columns in data: 15 (10 unique columns + 5 parsed columns from the 10)
\item
  Number of Unique rows in data: 98855
\end{itemize}

\section{3. Data Exploration}\label{data-exploration}

\subsubsection{The Analysis below are based on 98,855 developers who participated in the survey.}\label{the-analysis-below-are-based-on-98855-developers-who-participated-in-the-survey.}

\subsection{3.1 Country Pie Chart}\label{country-pie-chart}

In this survey we have respondents from more than 180 countries as shown in the pie chart below but most of respondents are from:

\begin{itemize}
\tightlist
\item
  United States 21.728\% Developers
\item
  India 13.05\% Developers
\item
  Germany 6.625\% Developers
\item
  United Kingdom 6.596\% Developers and
\item
  Canada 3.525\% Developers
\end{itemize}

This results shows that major user base of stack over flow is from United states and India.

\includegraphics[width=\textwidth]{./public/images/countrypiechart.png}

\subsection{3.2 Average Developer Salary by Country}\label{average-developer-salary-by-country}

This is the Mean salary range distribution with respect to countries.

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/AverageDeveloperSalarybyCountry.png}
\caption{``AverageDeveloperSalarybyCountry''}
\end{figure}

\subsection{3.3 Average Salary by Country}\label{average-salary-by-country}

This is the Column wise representation of the graph. According to the bar chart below, we can see that the countries who have respondents of 100 or more have lower salary number, like

\begin{itemize}
\tightlist
\item
  Ireland and United states respondents have salaries more than 100,000.
\item
  Norway, United Kingdom and Switzerland respondents have salary more than 80,000, and
\item
  Canada, Denmark and France have salary range between 60,000 to 80,000 \includegraphics[width=\textwidth]{./public/images/averagesalarybycountry.png}
\end{itemize}

\subsection{3.4 Salary Box}\label{salary-box}

In salary box, different types of developers are plotted against the salaries earned. In the graph below we can see that an Engineering Manager got the maximum salary of more than 8,000 while a Developer Specialist got a salary ranging from 40,000 to 75,000.

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/SALARYBOX.png}
\caption{``SalaryBox''}
\end{figure}

\subsection{3.5 Employment Status}\label{employment-status}

From the pie chart plot, around 75.24\% developers are employed full time.

\begin{itemize}
\tightlist
\item
  9.85\% work as a freelancer or self employed.
\item
  5.65\% are not employed and looking for work.
\item
  5.38\% employed as part time.
\item
  3.6\% are not employed and not looking for work.
\item
  0.19\% are retired.
\end{itemize}

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/employmentstatus.png}
\caption{``EmploymentStatus''}
\end{figure}

\subsection{3.6 Formal Education}\label{formal-education}

The Highest level of formal education of Developers are:

\begin{itemize}
\tightlist
\item
  Approx. 40,000 Developers having Bachelor's degree.
\item
  Approx. 20,000 Developers having Master's degree.
\item
  Approx. 11,000 having some college/university study without earning a degree.
\item
  Approx. 9,000 having Secondary schools(E.g. American high school, etc.).
\item
  Approx 3,000 having Associate degree.
\item
  Approx. 2,000 having other doctoral degree (PhD., Ed.D, etc.).
\item
  Approx. 1,500 having Primary/elementary school.
\item
  Approx. 1,500 having Professional degree (JD, MD etc.).
\item
  Approx. 1,000 never completed any formal education.
\end{itemize}

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/FormalEducation.png}
\caption{``FormalEducation''}
\end{figure}

\subsection{3.7 Programming Language}\label{programming-language}

As seen from graph below, most of the respondents used JavaScript, HTML and CSS as their preferred programming language.

\begin{itemize}
\tightlist
\item
  JavaScript is the most popular language used
\end{itemize}

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/ProgrammingLanguage.png}
\caption{``ProgrammingLanguage''}
\end{figure}

\subsection{3.8 Developer Type}\label{developer-type}

The results from the bar chart below, shows that about

\begin{itemize}
\tightlist
\item
  13,643 are Students.
\item
  5,909 are QA or test developers.
\item
  4,245 are Game or graphics developers.
\item
  15,056 are Desktop or enterprise applications developers.
\item
  7,195 are Data or business analysts.
\item
  9,821 are System administrators.
\item
  42,305 are Full-stack developers.
\item
  9,137 are DevOps specialists.
\item
  12,548 are Database administrator or.
\end{itemize}

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/developertype.png}
\caption{``DeveloperType''}
\end{figure}

\subsection{3.9 Framework}\label{framework}

From the survey carried out, Node.js, Angular, and React are the most popular frameworks which developers worked with in the year 2018, while Spring, TensorFlow and Hadoop were less appealing to most developers.

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/Framework.png}
\caption{``Framework''}
\end{figure}

\subsection{3.10 Languages Correlation}\label{languages-correlation}

This graph shows the Programming Languages correlating with one another. E.g JavaScript users have higher usage of HTML, CSS and SQL.

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/languagecorrelation.png}
\caption{``LanguagesCorrelation''}
\end{figure}

\subsection{3.11 OpenSource}\label{opensource}

According to the survey, the pie chart plot shows the number of developers that worked with open source tools.

\begin{itemize}
\tightlist
\item
  Approx. 56 \% developers did not work with open source tools, while
\item
  Approx. 44 \% developers worked with open source tools.
\item
  \includegraphics[width=\textwidth]{./public/images/OpenSource.png}
\end{itemize}

\subsection{3.12 Normal Distribution Years of Coding}\label{normal-distribution-years-of-coding}

As shown in the normal distribution below the average years of coding is 6 years. More details can be seen in the box plot below.

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/normaldistributionyearsofcoding.png}
\caption{``NormalDistributionYearsofCoding''}
\end{figure}

\subsection{3.13 Years of Coding Professionally}\label{years-of-coding-professionally}

The plot below shows that the

\begin{itemize}
\tightlist
\item
  The maximum number of years developers coded professionally is 26 years.
\item
  The average developer coded professionally for about 6 years.
\item
  50\% of the developers coded professionally between 3 - 12 years while
\item
  The number minimum of years developers coded professionally is 0 years.
\end{itemize}

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/yearsofcodingprofessionally.png}
\caption{``YearsofCodingProfessionally''}
\end{figure}

\subsection{3.14 Job Satisfaction}\label{job-satisfaction}

The pie chart shows the levels of job satisfaction of people with their current job.

\begin{itemize}
\tightlist
\item
  37.5 \% are Moderately satisfied.
\item
  17.9 \% are Extremely satisfied.
\item
  14.5 \% are Slightly satisfied.
\item
  10.2 \% are Slightly dissatisfied.
\item
  9.1 \% are Moderately dissatisfied.
\item
  7.2 \% are Neither satisfied nor dissatisfied.
\item
  3.6 \% are Extremely dissatisfied.
\end{itemize}

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/JobSatisfaction.png}
\caption{``JobSatisfaction''}
\end{figure}

\subsection{3.15 Job Satisfaction By Country}\label{job-satisfaction-by-country}

This shows the country wise distribution of the job satisfaction as explained earlier in the pie chart.

\begin{itemize}
\tightlist
\item
  About 11,670 developers in the United States are satisfied
\item
  5,172 developers in India are satisfied
\item
  3,499 developers in United Kingdom are satisfied
\item
  3,429 developers in Germany are satisfied
\item
  1,811 developers in Canada are satisfied
\item
  1,155 developers in Brazil are satisfied
\item
  1,132 developers in Australia are satisfied
\item
  1,092 developers in Poland are satisfied
\end{itemize}

\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{./public/images/JobSatisfactionByCountry.png}
\caption{``JobSatisfactionByCountry''}
\end{figure}

\subsection{4. Conclusion}\label{conclusion}

The survey analysis based on 98,855 developers from more than 180 countries shows that

\begin{enumerate}
\def\labelenumi{\arabic{enumi}.}
\tightlist
\item
  The country with the most respondents from the survey was The United States with 21.728\% while India had 13.05\% respondents, Germany 6.625\%, United Kingdom 6.596\%, and Canada 3.525\%.
\item
  Ireland and United States respondents have salaries more than 100,000. Norway, United Kingdom and Switzerland respondents have salary more than 80,000, while Canada, Denmark and France have salary range between 60,000 to 80,000.
\item
  About 9.85\% developers work as a freelancers or self employed, 5.65\% are not employed and looking for work, 5.38\% are employed as part time, 3.6\% are not employed and not looking for work and 0.19\% are retired.
\item
  Approximately 40,000 developers have Bachelor's degree, 20,000 developers having Master's degree, about 11,000 have some college/university study without earning a degree, about 2,000 have other doctoral degree (PhD., Ed.D, etc.) while 1,000 never completed any formal education.
\item
  Node.js, Angular, and React are the most popular frameworks which developers worked with in the year 2018.
\item
  Approximately 56 \% developers did not work with open source tools, while 44 \% developers worked with open source tools.
\item
  About 11,670 developers in the United States are satisfied while 5,172 developers in India are satisfied,and 1,811 developers in Canada are satisfied.
\end{enumerate}


\end{document}
